<?php
// BolGalleryCreative - 07/01/2005
// All right reserved to Nicolas d'Haussy
// Use or modify it at your own risk


// Retruns a GD image file resource create and its width and height into an array
// Output array : {image resource, image width, image height}
function getImageResource($imageFile) {

	// Get image info
	$imageFileInfo = getimagesize($imageFile);
	$dataArray[1] = $imageFileInfo[0];
	$dataArray[2] = $imageFileInfo[1];

	// Create a image resource
 	if ($imageFileInfo[2] == 1) { $imageFileResource = imagecreatefromgif($imageFile); }
	if ($imageFileInfo[2] == 2) { $imageFileResource = imagecreatefromjpeg($imageFile); }
 	if ($imageFileInfo[2] == 3) { $imageFileResource = imagecreatefrompng($imageFile); }
	$dataArray[0] = $imageFileResource;
	
	return $dataArray;
}



// Creates a jpeg image sized as you want focusing randomly at a detail of the reference image
function imageDetailExtract($referenceImage, $thumbnail, $thumbnailWidth, $thumbnailHeight, $thumbnailJpegQuality=70) {

	$getImageResource = getImageResource($referenceImage);
	
	// Method to display a image detail
	// Coders : problems with little images (To get rid of it, set those two variables to 0)
	// Coders : could be also enhanced so as to see more details
	$Xposition = round(rand(0, ($getImageResource[1]-$thumbnailWidth)));
	$Yposition = round(rand(0, ($getImageResource[2]-$thumbnailHeight)));

	// Create the detail image
	$thumbnailResource = imagecreatetruecolor($thumbnailWidth,$thumbnailHeight);
	imagecopy($thumbnailResource, $getImageResource[0], 0, 0, $Xposition, $Yposition, $getImageResource[1], $getImageResource[2]);
	imagejpeg($thumbnailResource, $thumbnail, $thumbnailJpegQuality);
	
	// Destroy image resources
	imagedestroy($getImageResource[0]);
	imagedestroy($thumbnailResource);
}



// Resizes the given image outputting a jpeg image
function resizeImage($referenceImage, $thumbnail, $maxWidth, $maxHeight, $thumbnailJpegQuality=70) {
	
	$getImageResource = getImageResource($referenceImage);
	
	// Recompute size for fitting
	if( $getImageResource[1] > $getImageResource[2]) { $maxHeight = round(($getImageResource[2]/$getImageResource[1])*$maxWidth); }
	else { $maxWidth = round(($getImageResource[1]/$getImageResource[2])*$maxHeight); }

	// Create resized image
	$thumbnailResource = imagecreatetruecolor($maxWidth,$maxHeight);
	imagecopyresized($thumbnailResource, $getImageResource[0], 0, 0, 0, 0, $maxWidth, $maxHeight, $getImageResource[1], $getImageResource[2]);
	imagejpeg($thumbnailResource, $thumbnail, $thumbnailJpegQuality);
	
	// Destroy image resources
	imagedestroy($getImageResource[0]);
	imagedestroy($thumbnailResource);
}



// Date sorting method
function mtime_sort($b, $a) { 

	if (filemtime($a) == filemtime($b)) {
		return 0; 
	} else {
		return (filemtime($a) < filemtime($b)) ? -1 : 1; 
	}
} 



// Main function that builds this complete gallery system. Call it on your php pages where you want it build a gallery.
function bolGallery($referenceImagesDirectory, $tableColumnsNb, $thumbnailWidth, $thumbnailHeight, $switchClassic=false, $saveHTMLpage=true) {

	if (is_dir($referenceImagesDirectory)) { 

		// Create the thumbnails directory if doesn't exist
		$thumbnailsDirectoryName = "bolGallery";
		if (! is_dir($referenceImagesDirectory.$thumbnailsDirectoryName)) {
			mkdir($referenceImagesDirectory.$thumbnailsDirectoryName, 0700);
		}

		// Build an array images url to be redistributed on building the page.
		// Checks the reference images directory (Doesn't scan subdirectories)
		// Coders : it would be great to find a solution to list the dir immediatly by date. Works in two loop right now :(

		$handle=opendir($referenceImagesDirectory);
		while ($file=readdir($handle)) {

			if (is_file($referenceImagesDirectory.$file)) {

				// Check if the file is a image
				$extension = strtolower(substr(strrchr($file,  "." ), 1));
				$supportedExtensions = array("jpg", "jpeg", "gif", "png");

				if (in_array($extension, $supportedExtensions) and ($file[0] != "#")) { // Also checks whether file is marked by a "#"

					// Add this file to the image files array
					$imagesList[] = $referenceImagesDirectory.$file;
				}
			}
		}
		closedir($handle);
		
		// Sort image files array by date with "mtime_sort" method
		@usort($imagesList, "mtime_sort") or die("There are no image in <b>" . $referenceImagesDirectory . "</b> to run bolGallery.");
		
		// Build gallery HTML source
		$HTML;


// Bolgallery CSS style class
$bolGalleryStyle = "\n\n<!-- BolGallery CSS style class -->
<STYLE type=\"text/css\">

	.bolGalleryStyle a img {
	
		border-style : solid;
		border-width : 1px;
		border-color : #000000;
	}
	
	.bolGalleryStyle a:hover img{
	
		border-style : dashed;
		border-width : 1px;
		border-color : #999999;
	}
</STYLE>\n\n";
$HTML .= $bolGalleryStyle;


// Bolgallery Javascript popup function
$bolGalleryPopup = "<!-- BolGallery Javascript popup window function -->
<SCRIPT type=\"text/javascript\">

function bolGalleryPopup(imageFile, width, height, title){

	var html = '<title>' + title + ' - Click to close </title><body leftmargin=0 topmargin=0 marginwidth=0 marginheight=0 onclick=\"javascript:window.close()\"><img src=\"' + imageFile + '\" alt=\"Click to close\"></body>';
	var popup = window.open(imageFile, '_blank', 'width=' + width+ ', height=' + height + ', status=no');
	popup.document.write(html);
	popup.focus();
}
</SCRIPT>\n\n";
$HTML .= $bolGalleryPopup;


		// Build the HTML table to display all the thumbnails
		$HTML .= "<!-- Generated by BolGallery - Nicolas d'Haussy - http://bolgallery.free.fr -->\n<TABLE border=0 class=\"bolGalleryStyle\">\n\t<TR valign=\"top\">\n";
		$table_i=0;

		foreach($imagesList as $currentImage) {


					// (Re)build the $currentName thumbnail url string
					$referenceImageName = str_replace($referenceImagesDirectory, "", $currentImage);
					$thumbnail = ($referenceImagesDirectory . $thumbnailsDirectoryName . "/thumbnail_" . $referenceImageName); 
	
					
					// Generate the thumbnail image if doesn't exist
					if(! file_exists($thumbnail)) {
					
						// Generate mode style thumbnail
						if($switchClassic) { resizeImage($currentImage, $thumbnail, $thumbnailWidth, $thumbnailHeight); } 
						else { imageDetailExtract($currentImage, $thumbnail, $thumbnailWidth, $thumbnailHeight); }
					}


					// Display the thumbnail image and set a popup link to the big one
					$referenceImageInfos = getimagesize($currentImage);
					$alt = str_replace("_", " ", substr($referenceImageName, 0, -4)); 
					$HTML .= "\t\t<TD>\n\t\t\t<A href=\"" . $currentImage . "\" onClick=\"bolGalleryPopup(this.href, " . $referenceImageInfos[0] . ", " . $referenceImageInfos[1] . ", '" . $alt . "'); return(false);\">";
					$HTML .= "\n\t\t\t\t<IMG src=\"" . $thumbnail . "\" title=\"" . $alt . "\">";
					$HTML .= "\n\t\t\t</A>\n\t\t</TD>\n";
					
					// HTML table next line evaluation
					$table_i++;
					if (($table_i % $tableColumnsNb) == 0) {
						$HTML .= "\t</TR>\n\t<TR valign=\"top\">\n";
					}
		}
		$HTML .= "\t</TR>\n\t<TR>\n\t\t<TD colspan=" . $tableColumnsNb . ">\n\t\t\t<FONT size=1>Gallery generated by <A href=\"http://bolgallery.free.fr\" target=\"_blank\">bolGallery</A></FONT>\n\t\t</TD>\n\t</TR>\n"; // Modify this discrete line at your own risk
		$HTML .= "</TABLE>\n<BR>\n<!--End BolGallery-->\n\n";
		print $HTML;
		
		
		// Bake HTML page source bolGallery output to file
		// Coders : could improve it to a kind of permalink system
		if($saveHTMLpage) {

			$HTMLpage = "bolGallery.html";
			// unlink($HTMLpage);
			$session = fopen($HTMLpage, "w"); // best fopen mode should be r+
			fputs($session, $HTML);
			fclose($session);
		}

	} else { die("<b>" . $referenceImagesDirectory . "</b> does not exist or is not a valid directory url. Cannot run bolGallery."); }
}
?>
