<?php //XTemplate.inc.php v0.02 (QuickHack) - (c) by Jack (tR) (http://www.jtr.de/scripting/php)

	define("SEP_NL",      "<!--%NL%-->");
	define("SEP_TMPL_NL", "<!--%TEMPL-NL%-->");

class XTemplate
{


	/**
	* @return void
	* @param  string $file
	* @desc   Loads file for into memory for partial replacement
	*/
	function load_file( $file )
	{
		$this->templ_content = "";
		
		// read file
		if (!$my_file = file( $file ))
		{ echo "XTemplate-Error: Could not open file $file"; exit; }
		
		// build to string
		$my_file = implode( SEP_NL, $my_file );

		// remove line breaks
		$my_file = ereg_replace( "(\r\n|\n|\r)", SEP_TMPL_NL, $my_file );

		$this->templ_content = $my_file;

		$this->num_replacements = 0;
		$this->tags = array();
		$this->replacements = array();
	}
	


	/**
	* @return void
	* @param  string $mydata
	* @desc   Loads data directly into memory
	*/
	function load_data( $mydata )
	{
		$this->templ_content = "";
		
		if (empty( $mydata ) )
		{ echo "XTemplate-Error: No data for replacement"; exit; }

		if (!is_string( $mydata ) )
		{ echo "XTemplate-Error: data string expected"; exit; }		
		
		// remove line breaks
		$my_file = ereg_replace( "(\r\n|\n|\r)", SEP_TMPL_NL, $mydata );

		$this->templ_content = $my_file;

		$this->num_replacements = 0;
		$this->tags = array();
		$this->replacements = array();
	}	
	

	/**
	* @return string
	* @desc   returns content of template buffer
	*/
	function get_template()
	{
		return $this->templ_content;		
	}
	
	
	function replace( $var, $substitute )
	// Task:  Prepares replacement of Tags in Template
	//
	// Input: $var        = Tag/Signature that indicates template variable
	//        $substitute = content to replace for this template var
	//
	{
		$num = $this->num_replacements++;	
		$this->tags[$num]         = "/".$var."/";
		$this->replacements[$num] = $substitute;
	}
	
	
	function replaced()
	// Task:  Returns the resul of template replacement
	//
	{
		$results = preg_replace( $this->tags, $this->replacements, $this->templ_content);

		$results = ereg_replace( SEP_TMPL_NL, "\n", $results );
		$results = ereg_replace( SEP_NL, "", $results );
		return $results;
	}
}

?>