<?php

	/*
		Jax Guestbook v3.4eta - Copyright (c) 2000-2004, Andreas John aka Jack (tR)
		This program and it's moduls are Open Source in terms of 
		General Public Licens (GPL) v2.0 - see http://www.fsf.org

		guestbook.inc.php (main module)
	*/

	// fit if nescessary:
	define( "PATH_TO_SCRIPT", "../" );

	// Global variables (have to be fit)
	require_once ( dirname(__FILE__) . "/".PATH_TO_SCRIPT."settings/guestbook.settings.inc.php");
	
	// (If exists) include localization file for the favoured language
	if ( file_exists( dirname(__FILE__) ."/".PATH_TO_SCRIPT."languages/jgb_" . $language . ".inc.php" ) )
		define( "LOC_LANG", $language ); 
	else
		define( "LOC_LANG", $default_language ); 
	
	require_once ( dirname(__FILE__) ."/".PATH_TO_SCRIPT."languages/jgb_" . LOC_LANG . ".inc.php" );
	
	
	if ( $data_source == "mysql" )
	{
		// include class for database support
		require_once ( dirname(__FILE__) ."/classes/mysql.inc.php" );
	
		// prepare list objects for database access
		$gb             = new mysql;
		$gb->name       = $guestbookfile;
		$gb->server     = $db_server;
		$gb->login      = $db_login;
		$gb->password   = $db_password;
		$gb->database   = $db_database;
		$gb->order_criterion = "ORDER BY 'date' DESC";
		$gb->init();
	
		$bf             = new mysql;
		$bf->name       = $blocking_file;
		$bf->server     = $db_server;
		$bf->login      = $db_login;
		$bf->password   = $db_password;
		$bf->database   = $db_database;
		$bf->init();
	}

	if ( $data_source == "csvfile" )
	{
		// include class for csv-textfile support
		require_once ( dirname(__FILE__) ."/classes/csvfile.inc.php" );
	
		// prepare list objects for file access
		$gb         = new csvfile;
		$gb->name   = "data/".$guestbookfile;
		$gb->init();
	
		$bf         = new csvfile;
		$bf->name   = "data/".$blocking_file;
		$bf->init();
	}

	$ox_tail = "guestbook_id=$guestbook_id&language=$language";
	
	echo <<<GB_HEAD

<!-- JAX GUESTBOOK START ---->

	<meta http-equiv="Content-Type" content="text/html; charset=$charset">
	<link rel="stylesheet" href="$css_file">
	<meta http-equiv="cache-control" content="no-cache">
  	<meta http-equiv="pragma" content="no-cache">
  	<meta http-equiv="expires" content="0">

  	<div class="jax_gb">
  	
GB_HEAD;


	/**
	* @return void
	* @desc   blocks the IP address of a visitor for a short time
	*/
	function block_ip()
	{
		global $blocking_period, $bf, $REMOTE_ADDR;
		
		// duration of the block (more than 3 hours are senseless!)
		$stamp = gmmktime() + $blocking_period * 60;

		$dummy = array();
		$dummy["ip"] = strval( $REMOTE_ADDR );
		$dummy["timestamp"] = $stamp;

		$bf->append( $dummy );
	}

	/**
	* @return void
	* @desc   checks whether the ip address of the surfer is invalid
	*/
	function check_ip( )
	{

		global $loc_lang, $bf, $REMOTE_ADDR;

		$stamp = gmmktime();
		
		$max = $bf->entries();
		$search_pattern = array();
		$search_pattern["ip"] = $REMOTE_ADDR;
		$position = $bf->find_entry( $search_pattern );

		if ( $position < $max )
		{
			$entry = array();
			$bf->get_entry( $position, $entry );

			// does the visitor try to spam the guestbook?
			if ( ($entry["ip"] == $REMOTE_ADDR ) and 
			($stamp <= $entry["timestamp"]) )
			{
				echo $loc_lang["like_you_anyway"];
				exit();
			}
		}

	}

	/**
	* @return void
	* @desc   deletes expired ip addresses from ip block file
	*/
	function remove_expired_ipblocks()
	{					
		global $bf;
		
		$stamp = gmmktime();
		$max = $bf->entries();
	
		for ( $i=0; $i<$max; $i++ )
		{
			$bf->get_entry( $i, $entry );
	
			if ( $stamp > $entry["timestamp"] )
			{
				$bf->delete( $i );
			}
		}	
	}	
	
	/**
	* @return void
	* @param  array $entry_data
	* @desc   notifies the webmaster by e-mail if a new guestbook entry was made
	*/
	function email_notification( $entry_data )
	{
		global $administrator_address, $loc_lang, $guestbook_id, 
		$SERVER_NAME, $SCRIPT_NAME, $gmt_ofs, $language, $quick_admin, $_local_date_format, $_local_time_format;

		$mailheader =
		trim( "From: ".$loc_lang["guestbook"]." <jax_guestbook@".$SERVER_NAME.">\n"
		. "Reply-To: ".$loc_lang["guestbook"]." <jax_guestbook@".$SERVER_NAME.">\n"
		. "X-Mailer: PHP " . phpversion() );

		// shortens the pathname by scriptname
		$script_path_dummy = explode( "/", $SCRIPT_NAME );
		unset ( $script_path_dummy[ count( $script_path_dummy ) - 1 ] );

		$admin_script_url = "http://" . $SERVER_NAME
		. implode("/",$script_path_dummy )
		. "/admin/guestbook.admin.php?guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs&language=$language";

		$gb_url = "http://".$SERVER_NAME.$SCRIPT_NAME.'?guestbook_id='.$guestbook_id;
		$message = "";
		$xkey = $entry_data["xkey"];
		
		$entry_data["date"] = gmdate( $_local_date_format, $entry_data["date"] );
		$entry_data["time"] = gmdate( $_local_time_format, $entry_data["time"] );
		
		if ($quick_admin)
		{
			$keys = array_keys( $entry_data );
			foreach ($keys as $key)
			{
				if ( $key != "hide_entry" AND $key != "xkey" ) 
					$message .= $key." : ".$entry_data[$key]."\n";
			}
			
			$message  .= "\n\n"
			  . $loc_lang["permit"].":\n".$admin_script_url."&action=enable&entry=$xkey\n\n"
			  . $loc_lang["delete"].":\n".$admin_script_url."&action=delete&entry=$xkey\n\n"
			  . $loc_lang["change"].":\n".$admin_script_url."&action=edit&entry=$xkey\n";
		}
		else
		$message  = trim( $loc_lang["new_entry"]."\n\n".$gb_url." !\n\n".$loc_lang["guestbook_admin_tool"]." :\n".$admin_script_url."\n" );

		$subject  = trim( $loc_lang["new_entry"]."\n" );
		$email    = trim( $administrator_address );
		
		mail( $email, $subject, $message, $mailheader );
	}

	/**
	* @return string
	* @param  string $bad_text
	* @param  integer $max_chars
	* @desc   Forces line and word wraps in the text
	*/
	function wrap_words( $bad_text, $max_chars )
	{

		$lines = explode( " ", $bad_text );

		$nice_text = "";
		for ( $i=0; $i < count($lines); $i++ )
		{
			if ( strlen($lines[$i]) > $max_chars )
			{
				$lines[$i] = chunk_split( $lines[$i], $max_chars , " " );
			}
			$nice_text .= $lines[$i]." ";
		}

		return $nice_text;

	}

	/**
	* @return string
	* @param  string $bad_text
	* @param  integer $len
	* @desc   cleans HTML form input (removes tags and cuts oversize)
	*/
	function clean_html_input( $bad_text, $len )
	{
		global $loc_lang; 
		
		$nice_text = strip_tags( $bad_text );

		// Shortens (if neccessary)
		$nice_text = substr( $nice_text, 0, $len );
		
		// Remove HTML "Script" - Tag (also if filter_HTML is disabled)
		if ( eregi("[<][Ss][Cc][Rr][Ii][Pp][Tt]|JavaScript:", $nice_text) )
		{
			echo $loc_lang["nice_try"];
			block_ip();
			exit;
		}
		
		return $nice_text;
		
	}


	/**
	* @return void
	* @desc   store new entry to guestbook
	*/
	function new_guestbook_entry()
	{
		global $gb, $loc_lang, $filter_html, $filter_badwords, $permission_required, 
		$administrator_notification, $filter_multiposting, $language, $max_message_size, 
		$separate_input_window;
		
		check_ip();
	
		if ( !empty( $_POST[ "email_protection" ] ) ) { $sec_mail = "1"; } else { $sec_mail = "0"; }
		if ( !empty( $_POST[ "message" ] ) )  $msg = clean_html_input( $_POST[ "message" ], $max_message_size); else exit;
		if ( !empty( $_POST[ "name" ] ) )	  $name = clean_html_input( $_POST[ "name" ], 30 ); else $name = "";
		if ( !empty( $_POST[ "age" ] ) )	  $age = clean_html_input( $_POST[ "age" ], 3 ); else $age = "";
		if ( !empty( $_POST[ "location" ] ) ) $location = clean_html_input( $_POST[ "location" ], 30 );	else $location = "";
		if ( !empty( $_POST[ "mail" ] ) )	  $mail = clean_html_input( $_POST[ "mail" ], 100 ); else $mail = "";
		if ( !empty( $_POST[ "homepage"] ) )  $homepage = clean_html_input( $_POST[ "homepage" ], 100 ); else $homepage = "";
		if ( !empty( $_POST[ "icq"] ) ) 	  $icq = clean_html_input( $_POST[ "icq" ], 12 ); else $icq = "";
	
		// clear HTML-Tags ?
		if ( $filter_html == true ) $msg = strip_tags( $msg );	

		// Clear line breaks from message!!
		$msg = ereg_replace("(\r\n|\n|\r)", "<br>", $msg);
	
		// Force line breaks if lines too long!
		$msg = wrap_words( $msg, 55 );
	
		// Clear again linebreaks!
		$msg = ereg_replace("(\r\n|\n|\r)", "<br>", $msg);
	
		// Shortens message if neccessary !
		$msg = substr( $msg, 0, $max_message_size );
	
		if ( $filter_badwords == true )
		{
			// Read list with bad words
			$wordlist = file ( "languages/jgb_" . $language . ".insults.txt" );
	
			$words = array_values( $wordlist );
	
			$insults = 0;
			$dummy = strtolower( $msg );
			foreach ( $words as $swearword )
			{
				// Contains the message one of the bad words?
				if ( strstr( $dummy , trim($swearword) ) )
				{
					$insults++;
					// If pain threshold exceeded block the user's ip
					if ( $insults >= $insults_tolerance )
					{
						$msg = "";
						block_ip();
						break;
					}
				}
			}
		}
	
		if ( !empty( $msg ) && !empty( $name ) )
		{
			$new_entry = array();
	
			$new_entry["date"]       = $ddate = gmmktime();
			$new_entry["time"]       = $ttime = $ddate;
			$new_entry["ip"]         = $iip = $_SERVER["REMOTE_ADDR"];
			$new_entry["name"]       = $name;
			$new_entry["mail"]       = $mail;
			$new_entry["age"]        = $age;
			$new_entry["location"]   = $location;
			$new_entry["homepage"]   = $homepage;
			$new_entry["icq"]        = $icq;
			$new_entry["sec_mail"]   = $sec_mail;
			$new_entry["message"]    = $msg;
	
			if ($permission_required) 
				$new_entry["hide_entry"] = "1"; 
			else 
				$new_entry["hide_entry"] = "";
	
			$new_entry["xkey"]       = $kkey = md5( $ddate.$iip.$msg );
	
			$red_data = array();
			$gb->get_entry( 0, $red_data );
	
			$i = 0;
			while ( $new_entry["date"] < $red_data["date"] )   
			{
				$gb->get_next_entry( $red_data );
				$i++;
			}
			$gb->insert( $i, $new_entry );			
			
			if ( $administrator_notification == true )
				email_notification( $new_entry );
	
			if ( $filter_multiposting == true ) block_ip();
		}
			
		echo "<p>{$loc_lang["thank_you_message"]}</p>";
		if ($permission_required) echo "<p>{$loc_lang["permission_info_message"]}</p>";
		
		if ($separate_input_window)
		{
			echo <<<CLOSESCRIPT
			<SCRIPT>
				this.window.opener.location.reload();
				window.close();
			</SCRIPT>
CLOSESCRIPT;
		}
		else echo '<meta http-equiv="refresh" content="5;URL='.$PHP_SELF."?guestbook_id=$guestbook_id&language=$language".'">';
		
		exit;
	
	}		

	require_once ( dirname(__FILE__) ."/classes/xtemplate.inc.php" );
	$mytpl = new XTemplate();
	$mytpl->load_file( dirname(__FILE__) ."/".PATH_TO_SCRIPT."templates/$gb_scheme.entries.tpl" );
	$tpl_entries = $mytpl->get_template();		
	
	
	/**
	* @return string
	* @param  array $entry
	* @desc   generates the formatted html code for a single guestbook entry
	*/
	function showentry( $alternate_linecolor, $entry_num, $entry )
	{
		global $language, $loc_lang, $input_icq, $fit_timezone,
		$timezone_offset, $gmt_ofs, $path_to_formmailer, $mytpl, $tpl_entries, 
		$_local_date_format, $_local_time_format, $tpl_entries, $ox_tail;

		$date   = $entry["date"];

		if ( $fit_timezone )
		{
			if ( $gmt_ofs == 0 && !empty( $timezone_offset ) )
			{
				$gmt_ofs = $timezone_offset;
			}

			// fit time to local timezone
			if ( !empty( $gmt_ofs ) && ( $gmt_ofs != 0 ) )
			{	
				$gmt_calced_date = $date + (3600 * $gmt_ofs);
				$date = gmdate( $_local_date_format, $gmt_calced_date );
				$time = gmdate( $_local_time_format, $gmt_calced_date );
			}
			
			if ($gmt_ofs > 0) $gmt_sign = "+"; 
			else $gmt_sign = " ";
			
			$timezone = "$gmt_sign $gmt_ofs";
		}

		$name   = $entry["name"];
		$mail   = $entry["mail"];
		$age    = $entry["age"];
		$state  = $entry["location"];
		$url    = $entry["homepage"];
		$icq    = $entry["icq"];

		// complete URL with "http://" if necessary
		if ( !empty( $url ) && (!eregi( "http://", $url )) )
		{
			$url = "http://".$url;
		}

		$msg    = $entry["message"];
		$sec_mail = $entry["sec_mail"];


//-------------------- Convert Smileys ---------------------------------------

		$msg = eregi_replace(":-\)\)|:\)\)|:biggrin:",
		'<img src="images/smileys/biggrin.gif" border="0">',$msg);

		$msg = eregi_replace(":-\)|:\)|:smile:",
		'<img src="images/smileys/smile.gif" border="0">',$msg);

		$msg = eregi_replace(":O\)|:o\)",
		'<img src="images/smileys/smile2.gif" border="0">',$msg);

		$msg = eregi_replace(";-\)|;\)|:wink:",
		'<img src="images/smileys/wink.gif" border="0">',$msg);

		$msg = eregi_replace(":-\(|:\(|:sad:",
		'<img src="images/smileys/sad.gif" border="0">',$msg);

		$msg = eregi_replace(":O\(|:o\(",
		'<img src="images/smileys/sad2.gif" border="0">',$msg);

		$msg = eregi_replace(":-D|:D|:happy:",
		'<img src="images/smileys/happy.gif" border="0">',$msg);

		$msg = eregi_replace(":heart:",
		'<img src="images/smileys/heart.gif" border="0">',$msg);

		$msg = eregi_replace(":-P|:P|:tongue:",
		'<img src="images/smileys/tongue.gif" border="0">',$msg);

		$msg = eregi_replace("8-\)|8\)|:cool:",
		'<img src="images/smileys/cool.gif" border="0">',$msg);

		$msg = eregi_replace(":-\(|:\(|:weep:",
		'<img src="images/smileys/weep.gif" border="0">',$msg);

		$msg = eregi_replace(":-o|:o|:astonished:",
		'<img src="images/smileys/surprised.gif" border="0">',$msg);

		$msg = eregi_replace(":kiss:|:-\*",
		'<img src="images/smileys/kiss.gif" border="0">',$msg);

		$msg = eregi_replace(":tired:|(\*-O)",
		'<img src="images/smileys/tired.gif" border="0">',$msg);

		$msg = eregi_replace(":smoke:|:-Q",
		'<img src="images/smileys/smoke.gif" border="0">',$msg);

// ---------------------------------------------------------------------------


		// Generate output string
		$outputstr = <<<OUTPUTSTR
<p id="guestbook_date">$date $time $timezone</p>
<p id="guestbook_name">
OUTPUTSTR;

		$mail_pic_link = ""; $mail_text_link = "";
		if (!empty( $mail )) 
		{
			if ($sec_mail == "0") 
			  $mail_link = "mailto:" . $mail;
			else
			{
				if ( !empty($entry["xkey"]) )
					$ciph_id = $entry["xkey"];
				else
					$ciph_id = md5( $entry["date"].$entry["ip"].$entry["message"]);

				$mail_link = $path_to_formmailer.'?mailto=' . $ciph_id."&$ox_tail";
			}
			$mail_pic_link = '<a href="'.$mail_link.'" target="_blank"><img src="images/email.gif" border="0" title="'.$loc_lang["mailaddress"].'"></a>';
			$mail_text_link = '<a href="'.$mail_link.'" target="_blank">'.$mail_link.'</a>';			
		}
		else $mail_link = "";
		
		if (!empty($url))
		{
			if (strlen( $url ) > 55 ) $url_title = substr( $url, 0, 50 ) . "...";
			else $url_title = $url; 
		}

		// convert URLs in message to hyperlinks
		$msgtext = nl2br( ereg_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]",
		               "<a href=\"\\0\">\\0</a>", $msg) );

		$outputstr .= '<br><br></p><p id="guestbook_message">'
		. $msgtext . "</p><p>&nbsp;</p>";

		$mytpl->load_data( $tpl_entries );

		$ii = $alternate_linecolor%2; 
		
		if (!empty( $icq ) ) $icq_flower = '<A HREF="http://wwp.icq.com/scripts/search.dll?to='.$icq.'"><IMG BORDER=0 SRC="http://wwp.icq.com/scripts/online.dll?icq='.$icq.'&img=5" title="ICQ Status" width="18" height="18"></A>'; 
		else $icq_flower = "";

		if (!empty( $state ) && !empty( $age ) ) 
		  $age_n_location = $age . $loc_lang["yearsold"].", ".$loc_lang["from"]." ".$state;
		else
		  if (!empty( $age ) ) $age_n_location = $age;
		  else
		    if (!empty( $state ) ) $age_n_location = $state;
		  
		if (!empty( $age_n_location ) ) $age_n_location = "(" . $age_n_location . ")";
		
		$mytpl->replace( "%!line_color!%", $ii );
		$mytpl->replace( "%!num_entry!%", $entry_num );
		$mytpl->replace( "%!date!%", $date );
		$mytpl->replace( "%!icq_flower!%", $icq_flower );
		$mytpl->replace( "%!time!%", $time );
		$mytpl->replace( "%!gmt_offset!%", $timezone );
		$mytpl->replace( "%!name!%", $name );		
		$mytpl->replace( "%!location!%", $state );		
		$mytpl->replace( "%!age!%", $age );
		$mytpl->replace( "%!age_n_location!%", $age_n_location );
		$mytpl->replace( "%!homepage_url!%", $url );
		$mytpl->replace( "%!homepage_title!%", $url_title );

		$url_pic_link = "";
		$url_text_link = "";
		if (!empty( $url ) ) 
		{
			$url_pic_link = '<a href="'.$url.'" target="_blank"><img src="images/home.gif" border="0" title="'.$loc_lang["homepage"].'"></a>';
			$url_text_link = '<a href="'.$url.'" target="_blank">'.$url_title.'</a>';
		}			
		$mytpl->replace( "%!homepage_pic_link!%", $url_pic_link );		
		$mytpl->replace( "%!homepage_text_link!%", $url_text_link );
		$mytpl->replace( "%!mail_link!%", $mail_link );
		$mytpl->replace( "%!mail_pic_link!%", $mail_pic_link );
		$mytpl->replace( "%!mail_text_link!%", $mail_text_link );
		$mytpl->replace( "%!mail_pic_link!%", $mail_pic_link );
		$mytpl->replace( "%!message!%", $msgtext );
		
		return $mytpl->replaced();
	}

	
	/**
	* @return void
	* @desc   shows guestbook sign in form only
	*/
	function show_sign_in_form()
	{

		global $gb, $gmt_ofs, $language, $guestbook_id, $entries_per_page, $separate_input_form, $gb_scheme, $loc_lang, $input_name, $input_name_forced, 
		$input_age, $input_age_forced, $input_city, $input_city_forced, $input_email, $input_email_forced, $input_homepage, $input_homepage_forced, $input_icq, $input_icq_forced, $email_protection, $max_message_size, $do;
		
		// JavaScript checking routines for the HTML input forms...
		require dirname(__FILE__)."/jgb_js.inc.php";
		
		echo $jschecks;
		
		// apply guestbook form template		
		$gb_tpl = new XTemplate();
		$gb_tpl->load_file( dirname(__FILE__) ."/".PATH_TO_SCRIPT."templates/$gb_scheme.sign_form.tpl" );
		
		$gb_tpl->replace("%!jgb_script!%",$_SERVER["PHP_SELF"]."?do=save_entry&language=$language&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs");
		
		$gb_tpl->replace("%!input_name_title!%",$loc_lang["name"]);
		$gb_tpl->replace("%!input_name_form!%",'<input type="text" name="name" size="15" maxlength="30">' );
		$gb_tpl->replace("%!input_age_title!%",$loc_lang["age"]);
		$gb_tpl->replace("%!input_age_form!%",'<input type="text" name="age" size="10" maxlength="3">');		
		$gb_tpl->replace("%!input_city_title!%",$loc_lang["city"]);
		$gb_tpl->replace("%!input_city_form!%",'<input type="text" name="location" size="15" maxlength="30">');		
		$gb_tpl->replace("%!input_mailaddress_title!%",$loc_lang["mailaddress"]);
		$gb_tpl->replace("%!input_mailaddress_form!%",'<input type="text" name="mail" size="40" maxlength="100">');
		$gb_tpl->replace("%!input_icq_title!%",$loc_lang["icq"] );
		$gb_tpl->replace("%!input_icq_form!%",'<input type="text" name="icq" size="15" maxlength="12">' );
		$gb_tpl->replace("%!input_ciphermail_title!%",$loc_lang["email_ciphering"]);
		$gb_tpl->replace("%!input_ciphermail_check!%",'<input type="checkbox" name="email_protection" value="1" checked>');
		$gb_tpl->replace("%!input_homepage_title!%",$loc_lang["homepage"]);
		$gb_tpl->replace("%!input_homepage_form!%",'<input type="text" name="homepage" size="65">');				
		$gb_tpl->replace("%!input_message_title!%",$loc_lang["comment"]);
		$gb_tpl->replace("%!input_message_form!%",'<textarea id="message" name="message" rows="5" cols="50" onKeyup="return show_chars_left();"></textarea>'."\n".'<div id="charsleft" style="text-align: right">'.$max_message_size."</div>\n" );
		$gb_tpl->replace("%!input_sendbutton_title!%",$loc_lang["signin"]);
		$gb_tpl->replace("%!input_smileyhelp_title!%", $loc_lang["help"] );
		
		
		echo $gb_tpl->replaced();
		
		echo <<<JS
<script>

  var max_msg_size = $max_message_size;

  function show_chars_left()
  {

    infodiv = document.getElementById("charsleft");
    messdiv = document.getElementById("message");
    
    if ( messdiv.value.length >= max_msg_size ) 
      messdiv.value = messdiv.value.substr(0,max_msg_size);
    
    infodiv.innerHTML = (max_msg_size - messdiv.value.length);

  }
</script>
JS;

	}	
		
	
	/**
	* @return void
	* @desc   shows guestbook
	*/
	function show_guestbook()
	{

		global $gb, $entries_per_page, $separate_input_form, $language, $gb_scheme, $loc_lang, 
		$input_name, $input_name_forced, $input_age, $input_age_forced, $input_city, 
		$input_city_forced, $input_email, $input_email_forced, $input_homepage, 
		$input_homepage_forced, $input_icq, $input_icq_forced, $email_protection, $max_message_size, 
		$do, $guestbook_id;
		
		// Show current page of the Guestbook!
		if ( !empty( $_GET[ "page" ] ) ) $page = $_GET[ "page" ]; else $page = 1;
		if ($page > 1) $separate_input_form = true;
			
		$entries = $gb->entries();
		
		$maxpages = ceil( $entries / $entries_per_page );
		
		if ( $page < $maxpages ) $nextpage = $page+1; else $nextpage = $maxpages;
		$lastpage = $page-1;
			
		if ($page > 1) $seperate_input_form = true;
		
		if ( !$separate_input_form )
		{
			require ( "form.inc.php" );	// show sign in form
		}

		$input_box_lnk = "$PHP_SELF?do=sign_in&page=$page&language=$language&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs";
		$input_box_lnk_title = $loc_lang["sign_in_guestbook"];

		// Line of the file from where to start
		$first_entry = ($page-1) * $entries_per_page;
		if ($first_entry < 0) $first_entry = 0;
		
		// Line of the file where to end
		$last_entry = $page * $entries_per_page-1;
		if ($last_entry > $entries ) { $last_entry = $entries; }
		
		$entry = array(); $i=$first_entry;
		$gb->get_entry( $i, $entry );
		
		do 
		{
			if ($entry["hide_entry"] != true && $i < $entries )
			{ 
				$gb_entries_outputs .= showentry( $alternate_linecolor, $entries-$i, $entry );
				$alternate_linecolor = !$alternate_linecolor;
			}
			$gb->get_next_entry( $entry );
			$i++;
			
		} while ($i <= $last_entry );

		$prev_page_url = "$PHP_SELF?page=$lastpage&language=$language&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs";
		$prev_page_title = $loc_lang["last"];
		$cur_page_num  = "$page {$loc_lang["of"]} $maxpages";
		$next_page_url = "$PHP_SELF?page=$nextpage&language=$language&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs";
		$next_page_title = $loc_lang["next"];		

		$nav_nums = "";

		$page_nums_range = 10;
		$page_nums_middle = round( 10 / 2);

		
		if ( $page > $page_nums_middle )
		{
			$nav_nums = "[<a href=\"$PHP_SELF?page=0&language=$language&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs\">&lt;&lt;</a>] ";			
			
			$page_nums_start = $page - $page_nums_middle;
			$page_nums_end = $page + $page_nums_middle;
		}
		else 
		{
			$page_nums_start = 1; 
			$page_nums_end = $page_nums_range;
		}

		for ( $j=$page_nums_start; $j<$page_nums_end; $j++ )
		{
			if ($j <= $maxpages)
			{
				if ($j == $page) $nav_nums .= "(<b>$j</b>) "; 
				else $nav_nums .= "[<b><a href=\"$PHP_SELF?page=$j&language=$language&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs\">$j</a></b>] ";
			}
		}
		
		if ( $page < $maxpages-$page_nums_middle )
		{
			$nav_nums .= "[<a href=\"$PHP_SELF?page=$maxpages&language=$language&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs\">&gt;&gt;</a>] ";			
			
			$page_nums_start = $page - $page_nums_middle;
			$page_nums_end = $page + $page_nums_middle;
		}
		

		if ( $separate_input_form )
		{
			$gb_tpl2 = new XTemplate();
			$gb_tpl2->load_file( dirname(__FILE__) ."/".PATH_TO_SCRIPT."templates/$gb_scheme.sign_in_link.tpl" );
			$gb_tpl2->replace("%!input_box_url!%",$input_box_lnk );
			$gb_tpl2->replace("%!input_box_lnk_title!%",$input_box_lnk_title );
			$input_form_code = $gb_tpl2->replaced();
		}

		// apply guestbook body template		
		$gb_tpl = new XTemplate();
		$gb_tpl->load_file( dirname(__FILE__) ."/".PATH_TO_SCRIPT."templates/$gb_scheme.body.tpl" );
		$gb_tpl->replace("%!guestbook_title!%",$htmltitle );
		$gb_tpl->replace("%!entries_block!%",$gb_entries_outputs );
		$gb_tpl->replace("%!nav_page_nums!%",$nav_nums);
		$gb_tpl->replace("%!nav_prev_page_url!%",$prev_page_url );
		$gb_tpl->replace("%!nav_prev_page_title!%",$prev_page_title );		
		$gb_tpl->replace("%!nav_cur_page_num!%",$cur_page_num );
		$gb_tpl->replace("%!nav_next_page_url!%",$next_page_url );
		$gb_tpl->replace("%!nav_next_page_title!%",$next_page_title );
		$gb_tpl->replace("%!input_box!%", $input_form_code );
		$gb_tpl->replace("%!input_box_url!%",$input_box_lnk );
		$gb_tpl->replace("%!input_box_lnk_title!%",$input_box_lnk_title );					
		echo $gb_tpl->replaced();
		
		echo $pagenavigation;
		remove_expired_ipblocks();				
	}		
	
	
	if ( !empty( $_GET["do"] ) ) $do = $_GET["do"]; else $do = "show_entries";

	switch ( $do )
	{
		case "show_entries" : show_guestbook(); 
			break;
		case "save_entry" : new_guestbook_entry();
			break;
		case "sign_in" 	: show_sign_in_form();
			break;			
		
	}
		

echo <<<GB_END

<p>&nbsp;</p>
<!-- You are allowed to move it, but please don't remove the LINK to the author's website!!! -->
<p class="author_info">Jax Guestbook v3.4eta by Jack (tR), <a href="http://www.jtr.de/scripting/php" target="_blank">www.jtr.de/scripting/php</a></p>
</div>

<!-- JAX GUESTBOOK END ---->

GB_END;

?>

